/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "dusk.h"
#include "net/packet.h"

typedef struct _client_t client_t;

typedef struct {
  int32_t clientSockDesc;
} clientremoteinit_t;

typedef struct {
  int32_t clientSockDesc;
  pthread_t thread;
} clientremote_t;

void clientRemoteInit(client_t *client, const clientremoteinit_t init);
void clientRemoteSend(client_t *client, const packet_t packet);
void * clientRemoteThread(void *arg);
void clientRemoteDispose(client_t *client);