/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "camera.h"

void cameraInit(camera_t *camera) {
  glm_mat4_identity(camera->projection);
  glm_mat4_identity(camera->view);
}

void cameraLookAt(
  camera_t *camera,
  const vec3 eye,
  const vec3 center,
  const vec3 up
) {
  glm_lookat(eye, center, up, camera->view);
}

void cameraPerspective(
  camera_t *camera,
  float aspect,
  float fovy,
  float zNear,
  float zFar
) {
  glm_perspective(fovy, aspect, zNear, zFar, camera->projection);
}

void cameraOrtho(
  camera_t *camera,
  float left,
  float right,
  float bottom,
  float top,
  float near,
  float far
) {
  glm_ortho(left, right, bottom, top, near, far, camera->projection);
}