/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "game.h"
#include "gametime.h"
#include "input.h"
#include "console/console.h"
#include "server/server.h"

#include "entity/entity.h"

void gameInit() {
  consoleInit();
  gameTimeInit();
  inputInit();

  serverInit();
  serverStart((serverstart_t){
    .type = SERVER_TYPE_LOCAL,
    .local = {
      .port = SERVER_LOCAL_PORT_DEFAULT
    }
  });

  entityInit(&ENTITY_TEST);
}

void gameUpdate(const float delta) {
  gameTimeUpdate(delta);
  inputUpdate();
  serverUpdate();
}

void gameDispose() {
  serverDispose();
}