/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "dusk.h"

typedef struct {
  float_t delta;
  float_t time;
} gametime_t;

extern gametime_t GAME_TIME;

#define GAME_TIME_STEP_DEFAULT 0.016f

/**
 * Initializes the game time.
 */
void gameTimeInit();

/**
 * Updates the game time.
 * 
 * @param delta The time since the last frame.
 */
void gameTimeUpdate(const float_t delta);