/**
 * Copyright (c) 2023 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "math.h"
#include "assert/assert.h"

int32_t mathClampi32(
  const int32_t value,
  const int32_t min,
  const int32_t max
) {
  assertTrue(max >= min, "mathClampi32: Max must be >= Min");
  if(value < min) return min;
  if(value > max) return max;
  return value;
}

int32_t mathModi32(int32_t value, int32_t modulo) {
  return ((value % modulo) + modulo) % modulo;
}