/**
 * Copyright (c) 2024 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "random.h"
#include "assert/assert.h"

bool_t RANDOM_IS_INITIALIZED = false;

void randomInit() {
  assertFalse(RANDOM_IS_INITIALIZED, "Random already initialized.");
  srand(1234567890);
  RANDOM_IS_INITIALIZED = true;
}

int32_t randomInt32() {
  assertTrue(RANDOM_IS_INITIALIZED, "Random not initialized.");
  return rand();
}

int32_t randomInt32Range(int32_t min, int32_t max) {
  return min + (rand() % (max - min));
}