/**
 * Copyright (c) 2024 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "dusk.h"

extern bool_t RANDOM_IS_INITIALIZED;

/**
 * Initializes the random number generator, and seeds it.
 */
void randomInit();

/**
 * Returns a random 32-bit integer.
 * 
 * @return Random 32-bit integer.
 */
int32_t randomInt32();

/**
 * Returns a random 32-bit integer within a given range.
 * 
 * @param min Minimum value.
 * @param max Maximum value (exclusive).
 * @return Random 32-bit integer within the given range.
 */
int32_t randomInt32Range(int32_t min, int32_t max);