/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "assert/assertgl.h"
#include "render.h"
#include "console/console.h"

render_t RENDER;

void renderInit() {
  memset(&RENDER, 0, sizeof(render_t));

  // Get OpenGL version
  const GLubyte *version = glGetString(GL_VERSION);
  const GLubyte *renderer = glGetString(GL_RENDERER);
  const GLubyte *vendor = glGetString(GL_VENDOR);
  const GLubyte *glslVersion = glGetString(GL_SHADING_LANGUAGE_VERSION);

  consolePrint("OpenGL Renderer");
  consolePrint("Version: %s", version);
  consolePrint("Renderer: %s", renderer);
  consolePrint("Vendor: %s", vendor);
  consolePrint("GLSL: %s", glslVersion);
}

void renderUpdate() {
}

void renderOverworld() {
}

void renderDispose() {
}