/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "duskgl.h"

typedef struct {
  int32_t nothing;
} render_t;

extern render_t RENDER;

/**
 * Initializes the render system.
 */
void renderInit();

/**
 * Updates the render system.
 */
void renderUpdate();

/**
 * Renders the overworld scene.
 */
void renderOverworld();

/**
 * Disposes of the render system.
 */
void renderDispose();