/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "duskglfw.h"

#define WINDOW_WIDTH_DEFAULT 800
#define WINDOW_HEIGHT_DEFAULT 600

extern GLFWwindow* window;
extern int32_t WINDOW_WIDTH;
extern int32_t WINDOW_HEIGHT;

/**
 * Initializes the game render window.
 * 
 * @return 0 on success, any other value on failure.
 */
int32_t windowInit();

/**
 * Returns whether the window should close.
 * 
 * @return true if the window should close, false otherwise.
 */
bool_t windowShouldClose();

/**
 * Updates the window subsystem.
 */
void windowUpdate();

/**
 * Disposes of the window.
 */
void windowDispose();